<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html"; charset=utf-8>
<title>Positional Language Models for Information Retrieval</title>
</head>

<body>

<h2 align="center"><font face="Arial Unicode MS">Positional Language Models 
(PLM)</font></h2>
<h2 align="center"><font face="Arial Unicode MS">(<a href="../plm.zip">Source 
code download</a>)</font></h2>
<p><font size="4" face="Arial Unicode MS">This is an implementation of the 
positional language model for ad hoc information retrieval. Please refer to the 
following paper for more details of the algorithm:<br>
<br>
[1] Yuanhua Lv and ChengXiang Zhai. &quot;<a href="../sigir09-plm.pdf">Positional 
Language Models for Information Retrieval</a>&quot;. In <i>Proceedings of the 32<sup>nd</sup> 
Annual International ACM SIGIR Conference on Research and Development in 
Information Retrieval</i> (<b>SIGIR&#39;09</b>), pages 299-306, 2009.<br>
<br>
The main source code file &quot;<a href="PLMRetEval.cpp">PLMRetEval.cpp</a>&quot; is 
implemented in C++ and works with the <a href="http://www.lemurproject.org/">
Lemur toolkit</a> (currently not supporting Indri search engine). Most of the 
codes were used in the experiments for our sigir&#39;09 paper. The algorithm has 
only been tested on <b>Lemur 4.10</b> (probably it can also work with other 
versions, but we haven&#39;t tested it yet) in a Linux environment, where the index 
type is &quot;key&quot;, built using the BuildIndex application provided by Lemur. </font></p>
<p><font size="4" face="Arial Unicode MS">The 
current version of the algorithm can only &quot;re-rank&quot; result documents retrieved 
by other retrieval models, 
e.g., language models + Dirichlet prior smoothing method (as default). Note that we did not 
change any internal implementation of Lemur. As for an experimental system, we 
haven&#39;t yet put too much effort to improve the efficiency, which could be done 
easily by using an index with term position information.</font></p>
<p><font size="4" face="Arial Unicode MS">The <a href="PLMRetEval.param">
PLMRetEval.param</a> file provides some recommended parameter settings. The 
PLM-specific parameters include <br>
<br>
<font color="#008000">&lt;!-- Number of documents to be ranked using PLM --&gt;<br>
&lt;RerankedDocCount&gt;2000&lt;/RerankedDocCount&gt;<br>
<br>
&lt;!-- Size of the &quot;soft&quot; passage (sigma) --&gt;<br>
&lt;PLMSigma&gt;175&lt;/PLMSigma&gt;<br>
<br>
&lt;!-- Propagation function: -1 Passage; 0 Gaussian; 1: Cosine; 2: Triangle; 3: 
Arc; 4: Circle--&gt;<br>
&lt;PropFunction&gt;0&lt;/PropFunction&gt;<br>
<br>
&lt;!-- Jelinek-Mercer Smoothing 0; Dirichlet prior Smoothing 1 --&gt;<br>
&lt;PLMSmoothMethod&gt;1&lt;/PLMSmoothMethod&gt;<br>
&lt;PLMJMLambda&gt;0.5&lt;/PLMJMLambda&gt;<br>
&lt;PLMDirPrior&gt;500&lt;/PLMDirPrior&gt;<br>
<br>
&lt;!-- The weight of PLM if we interpolate PLM with the original relevance score 
--&gt;<br>
&lt;PLMCoefficient&gt;1.0&lt;/PLMCoefficient&gt;<br>
<br>
&lt;!-- 1: do not use PLM for single-term query; 0: otherwise --&gt;<br>
&lt;IgnoreSingleTermQuery&gt;0&lt;/IgnoreSingleTermQuery&gt;<br>
</font><br>
<br>
Other parameters in the <a href="PLMRetEval.param">PLMRetEval.param</a> file are 
standard parameters used in Lemur. For example, you can also do a pseudo 
relevance feedback after re-ranking documents using PLM. </font></p>
<p><font face="Arial Unicode MS" size="4">Besides, we support standard 
Lemur query format, as shown below:<br>
<br>
<font color="#008000">&lt;DOC 301&gt;<br>
intern<br>
organ<br>
crime<br>
&lt;/DOC&gt;<br>
&lt;DOC 302&gt;<br>
poliomyel<br>
post<br>
polio<br>
&lt;/DOC&gt;<br>
&lt;DOC 303&gt;<br>
hubbl<br>
telescop<br>
achiev<br>
&lt;/DOC&gt;</font><br>
where 301-303 are query topic ids.
(Please note that for the above query topics, we have done stemming and stopword 
removal.)<br>
<br>
<br>
To run our algorithm, you need to first install the
<a href="http://www.lemurproject.org/">Lemur toolkit</a>. See
<a href="http://sourceforge.net/apps/trac/lemur/wiki/Compiling%20and%20Installing%20on%20Linux%20and%20Mac%20OS%20X">
http://sourceforge.net/apps/trac/lemur/wiki/Compiling and Installing on Linux 
and Mac OS X</a> for more details regarding compiling and installing Lemur 
toolkit on Linux and/or Mac OS X. After that, change the &quot;prefix&quot; 
value in the <a href="Makefile">Makefile</a> file to your 
installation path. </font></p>
<p><font size="4" face="Arial Unicode MS">Finally, you can compile our algorithm 
and run it like this: <b>PLMRetEval PLMRetEval.param</b><br>
<br>
<br>
If you have more questions, please email me (<a href="http://sifaka.cs.uiuc.edu/~ylv2">Yuanhua 
Lv</a>, ylv2@uiuc.edu)</font></p>

</body>

</html>
